// This file was generated by Dashcode from Apple Computer, Inc.
// You may edit this file to customize your Dashboard widget.

// - 日付ラベルのfolding GUI アイコン
//- QuickTimeの再生
//  => QuickTime partsを試みたが、指定のファイルを再生できず...
//- 拡大画像/動画loading時のloading...アイコン
//  => 画像はOK．動画は... いまいち．Intel版ではWidget内で再生できないので、意図した動作にならない
//- 写真/動画枚数のtooltips化
//  => ダサイからやめる
//- サムネイルの毎時別移動のスムーススクロール化
//- 動画が一目で分かるように
//  => いまいちうまくいかない => 無理矢理なんとかした
// 
//- 応募書類の文面作成
//- 解説用Webページ作成


// --- Global Variables --- 
// 写真の日付リスト (文字列の配列)
var photoDates=null;
var masterList=null;
var gPictArea=null;
var gPictBar=null;
var focusDate=null;
var currentMouseOverDate=null;
var selectedPhotoAttr=null;

// ----
function load()
{
	setupParts();
	
	// plug-inの存在確認
	if (!window.iPhotoAlbum) { alert("do not use iPhotoAlbum object!"); return; }
	
	// scrollAreaとscrollBarの構築
	var bx=document.getElementById('pictboxBar');
	if (!bx) { alert('No pictboxBar'); return; }
	gPictBar = new AppleVerticalScrollbar(bx);
	bx=document.getElementById('pictboxArea');
	if (!bx) { alert('No pictboxArea'); return; }
	gPictArea = new AppleScrollArea(bx, gPictBar);
	gPictArea.scrollsHorizontally = false;
	gPictArea.focus();
	
	// 日付リストの取得と、日付ボタンの構築
	photoDates = iPhotoAlbum.getDatesOfPhotos();
	setupDateButtons();
	if (photoDates.length > 0) { updateFocusDate(photoDates[0]); }
	// 対象日(focusDate)の写真群を表示する
	drawThumbsInDate();

	window.onfocus=function(){
		document.getElementById('dateBox').object.focus();
	}
	window.onblur=function(){
		document.getElementById('dateBox').object.blur();
	}
}

function remove()
{
	// your widget has just been removed from the layer
	// remove any preferences as needed
	// widget.setPreferenceForKey(null, createInstancePreferenceKey("your-key"));

	if (document.aMovie) { document.aMovie.Stop(); } // stop movie play 
}

function hide()
{
	// your widget has just been hidden stop any timers to
	// prevent cpu usage

	if (document.aMovie) { document.aMovie.Stop(); } // stop movie play
}

function show()
{
	// your widget has just been shown.  restart any timers
	// and adjust your interface as needed
	document.getElementById('dateBox').object.focus();
}

function showBack(event)
{
	// your widget needs to show the back

	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget)
		widget.prepareForTransition("ToBack");

	front.style.display="none";
	back.style.display="block";
	
	if (window.widget)
		setTimeout('widget.performTransition();', 0);
}

function showFront(event)
{
	// your widget needs to show the front

	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget)
		widget.prepareForTransition("ToFront");

	front.style.display="block";
	back.style.display="none";
	
	if (window.widget)
		setTimeout('widget.performTransition();', 0);
}

if (window.widget)
{
	widget.onremove = remove;
	widget.onhide = hide;
	widget.onshow = show;
}

//
// --- user defined functions ---
//

// 曜日名取得
function getDayOfWeekStr (dowVal) {
	var dw='';
	
	if (0==dowVal) {
		dw=localizedStrings["Sunday"];
	} else if (1==dowVal) {
		dw=localizedStrings["Monday"];
	} else if (2==dowVal) {
		dw=localizedStrings["Tuesday"];
	} else if (3==dowVal) {
		dw=localizedStrings["Wednesday"];
	} else if (4==dowVal) {
		dw=localizedStrings["Thursday"];
	} else if (5==dowVal) {
		dw=localizedStrings["Friday"];
	} else if (6==dowVal) {
		dw=localizedStrings["Saturday"];
	} else {
		dw='(unknown)';
	}

	return dw;
}

// 月名取得
function getMonthName (monVal) {
	var monnm='';
	
	if (1==monVal) {
		monnm=localizedStrings["January"];
	} else if (2==monVal) {
		monnm=localizedStrings["February"];
	} else if (3==monVal) {
		monnm=localizedStrings["March"];
	} else if (4==monVal) {
		monnm=localizedStrings["April"];
	} else if (5==monVal) {
		monnm=localizedStrings["May"];
	} else if (6==monVal) {
		monnm=localizedStrings["June"];
	} else if (7==monVal) {
		monnm=localizedStrings["July"];
	} else if (8==monVal) {
		monnm=localizedStrings["August"];
	} else if (9==monVal) {
		monnm=localizedStrings["September"];
	} else if (10==monVal) {
		monnm=localizedStrings["October"];
	} else if (11==monVal) {
		monnm=localizedStrings["November"];
	} else if (12==monVal) {
		monnm=localizedStrings["December"];
	} else {
		monnm='unknown';
	}

	return monnm;
}

// オブジェクトの絶対位置を取得する関数 
function getElementAbsPos(elem) {
	var obj=new Object();
	obj.x=elem.offsetLeft;
	obj.y=elem.offsetTop;
	
	while (elem.offsetParent) {
		elem=elem.offsetParent;
		obj.x+=elem.offsetLeft;
		obj.y+=elem.offsetTop;
	}
	
	return obj;
}

// ----
function Separator (classNm) {
	var dv=document.createElement('div');
	if (dv) {
		dv.setAttribute('class', classNm);
	}
	return dv;
}

// ----
function setupDateButtons () {
	// データが存在することを確認
	if (null==photoDates || photoDates.length < 1) {
		document.getElementById('pictboxArea').innerHTML='<h3>'+localizedStrings["nophotoMsg"]+'</h3>';
		alert("There is NO date list.");
		return;
	}
	
	var dtbx=document.getElementById('dateContent'); // 日付リスト用スクロールボックスのdivボックス
	dtbx.innerHTML=''; // 初期化
	
	// 日付リストを生成する
	var year=-1;
	var month=-1;
	
	// 日付ラベルに関し、年月日で階層化し、それを多次元配列として構築
	var dateObj=new Array();
	for (var i=0; i<photoDates.length; ++i) {
		var tmv=photoDates[i].split('-');
		if (year!=tmv[0] || month!=tmv[1]) {
			if (!dateObj[tmv[0]]) {
				dateObj[tmv[0]]=new Array();
				year=tmv[0];
			}
			if(!dateObj[tmv[0]][tmv[1]]) {
				dateObj[tmv[0]][tmv[1]]=new Array();
				month=tmv[1];
			}
		}
		
		dateObj[tmv[0]][tmv[1]].push(photoDates[i]);
	}
	
	var fnref=function (event) { setNumPhotoText(''); }
	
	// 構築した多次元配列を基に、DOM treeを構築
	for (var j in dateObj) {
		var ydiv=document.createElement('div');
		ydiv.setAttribute('class', 'yearSeparator');
		
		var ytl=document.createElement('div');
		ytl.setAttribute('class', 'yearTitle');
		ytl.setAttribute('fold', false);
		ytl.innerHTML='<img src="Images/openTri.png" />'+'&nbsp;&nbsp;'+j;
		ytl.addEventListener('click', foldDateLabels, false);
		ytl.addEventListener('mouseover', fnref, false);
		ydiv.appendChild(ytl);
		
		var yKodomo=document.createElement('div');
		ydiv.appendChild(yKodomo);
		
		for (var k in dateObj[j]) {
			var mdiv=document.createElement('div');
			mdiv.setAttribute('class', 'monthSeparator');
			
			var mtl=document.createElement('div');
			mtl.setAttribute('class', 'monthTitle');
			mtl.setAttribute('fold', false);
			mtl.addEventListener('click', foldDateLabels, false);
			mtl.addEventListener('mouseover', fnref, false);
			mtl.innerHTML='<img src="Images/openTri.png" />'+'&nbsp;&nbsp;'+getMonthName(k)+', '+j;
			mdiv.appendChild(mtl);
			
			var mKodomo=document.createElement('div');
			mdiv.appendChild(mKodomo);
			
			for (var l in dateObj[j][k]) {
				var dtdiv=document.createElement('div');
				dtdiv.setAttribute('class', 'dateLabelDiv');
				var dtLbl=dateObj[j][k][l];
				dtdiv.setAttribute('id', dtLbl);
				var tmv=dtLbl.split('-');
				dtdiv.innerHTML=tmv.splice(0,3).join('/')+" "+getDayOfWeekStr(tmv[0])
				setListenersToDateLabel(dtdiv);
				mKodomo.appendChild(dtdiv);
			}
			yKodomo.appendChild(mdiv);
		}
		dtbx.appendChild(ydiv);
	}
	
	// show scrollbar slider...
	document.getElementById('dateBox').object.refresh();
}

// ---
function foldDateLabels (event) {
	var root=this.parentNode;
	if (true==this.fold) {
		root.childNodes[1].style.display='block';
		this.fold=false;
	} else {
		root.childNodes[1].style.display='none';
		this.fold=true;
	}
	
	var x=this.getElementsByTagName('img');
	//alert('# of img tags: '+x.length);
	if (x.length>0) {
		if (this.fold) {
			x[0].src='Images/closeTri.png';
		} else {
			x[0].src='Images/openTri.png';
		}
	}

	// refresh scroll bar of date labels
	document.getElementById('dateBox').object.refresh();
	event.stopPropagation();
}

// ----
// focusDate(写真を表示している日付の値)を更新する関数
// あわせて、日付ラベルの色を更新している
function updateFocusDate(newFocusDate) {
	if (focusDate && focusDate.length > 0) {
		var fdbk=document.getElementById(focusDate);
		if (fdbk) {
			fdbk.style.color='black'; // 色を元に戻す
		}
	}

	var nfbk=document.getElementById(newFocusDate);
	if (nfbk && newFocusDate) {
		nfbk.style.color='blue'; // 注目日を青色で示す
	}
	
	focusDate=newFocusDate; // 値の更新

	// その日の写真と動画の枚数を画面下部に表示
	var numStr=setNumberOfPhotosAtDate(newFocusDate);
	var tmv=newFocusDate.split('-');

	// focusDateの写真/動画枚数を表示
	numStr+=' in '+tmv[0]+'/'+tmv[1]+'/'+tmv[2]+' '+getDayOfWeekStr(tmv[3]);
	document.getElementById('thumbNum').innerHTML=numStr;
}

// 日付ラベルにイベントリスナーを設定する関数
function setListenersToDateLabel(targetDateDiv) {
	// mouse cursorのfocusがあたった時は色を赤系色に
	targetDateDiv.addEventListener('mouseover', overDateLabel, false);
	
	// mouse cursorのfocusが外れた時は、黒色か青色に戻す
	targetDateDiv.addEventListener('mouseout', outDateLabel, false);
	
	// mouse clickの時はその日に撮影された写真を右側のpaneに表示する
	targetDateDiv.addEventListener('click', clickDateLabel, false);
}

// mouseover callback for date label
function overDateLabel(event) 
{
	// テキストラベルの色を元に戻す
	unfocusDateLabel();

	this.style.color='#cc3300'; // テストラベルの色を赤系の色にする

	// マウスカーソルが乗っている日付ラベルの日付(ID)を取得する
	var focusDateCandidate=event.target.id;
	if (focusDateCandidate == currentMouseOverDate) { return false; }
	currentMouseOverDate=focusDateCandidate;
	//alert('mouse over on '+currentMouseOverDate);
	
	// その日の写真/動画枚数を取得する
	var numStr=setNumberOfPhotosAtDate(currentMouseOverDate);
	// date label下の領域に枚数情報を表示する
	setNumPhotoText(numStr);
	
	// 写真/動画枚数のtooltips表示
	if (false) {
		var tips=document.getElementById('hideBox');
		tips.innerHTML='&nbsp;'+numStr+'&nbsp;';
		tips.style.visibility='visible';
		tips.style.top=(event.clientY-14)+'px';
		tips.style.left=event.clientX+'px';
	}

	return false;
}

// mouseout callback for date label
function outDateLabel(event) {
	//alert('mouse out from date label: '+currentMouseOverDate);

	// テキストラベルの色を元に戻す
	unfocusDateLabel();

	// date label下の写真の枚数表示を空白にする
	setNumPhotoText('');
	
	return false;
}

//
function unfocusDateLabel() {
	if (!currentMouseOverDate) { return false; }
	
	// これまでfocusのあたっていたdate labelを取得する
	var targetMouseOverDate=document.getElementById(currentMouseOverDate);
	
	// テキストラベルの色を元に戻す
	if (targetMouseOverDate) {
		if (currentMouseOverDate==focusDate) {
			targetMouseOverDate.style.color='blue';
		} else {
			targetMouseOverDate.style.color='black';
		}
	}
	
	// 再初期化
	currentMouseOverDate=null;
}

// 
function setNumPhotoText(textStr) {
	// date label下の写真の枚数表示を空白にする
	var lbl=document.getElementById('numPhotoText');
	if (lbl) { lbl.innerText=textStr; }
}

// 日付文字列を引数とし、その日の写真と動画の枚数を取得する関数
function setNumberOfPhotosAtDate (dateStr) {
	// plug-inからそれぞれの枚数を要素数2の配列としてJSON形式で取得する
	var cntAtDateStr = iPhotoAlbum.getNumOfPhotosbyDate(dateStr);
	if (null==cntAtDateStr) { return ''; }
	
	var cnts=eval(cntAtDateStr); // JSON形式 "[2, 0]"という値が返されているはず
	//alert("return value: "+cntAtDateStr);
	if (2!=cnts.length) { return ''; }
	
	var indicateStr='';
	if (cnts[0] > 0) {
		indicateStr+=cnts[0];
		if (cnts[0] > 1) {
			indicateStr+=' photos';
		} else {
			indicateStr+=' photo';
		}
	}
	if (cnts[1] > 0) {
		if (indicateStr.length > 0) { indicateStr+=' and '; }
		indicateStr+=cnts[1];
		if (cnts[1] > 1) {
			indicateStr+=' movies';
		} else {
			indicateStr+=' movie';
		}
	}
	
	return indicateStr;
}

// 
function clickDateLabel(event) {
	var nextFocusDate=event.target.id;
	//alert("clickDateLbl with ID: "+nextFocusDate);
	
	// 大画像が表示されていたら、まずそれを消す(非表示にする)
	disappearLargeImagePane();
	
	if ("" != nextFocusDate && focusDate!=nextFocusDate) {
		setIdleCursor(); // load中を示す画像を表示
		updateFocusDate(nextFocusDate); // focusDateの更新
		drawThumbsInDate(); // 写真内容の更新
	}
	
	event.stopPropagation();
	return false;
}

// focusDateの日付で撮影された写真を表示する
function drawThumbsInDate () {
	// plug-inからfocusDateに撮影された写真の属性情報をJSON形式で取得
	var jsonStr = iPhotoAlbum.getPhotoInfobyDate(focusDate);
	if (null==jsonStr) { alert("No photos in date: "+focusDate); return; }
	
	masterList=eval(jsonStr); // 特定日付の写真リストを取得
	masterList.sort(sortPhotosByEpoch); // 時刻値でソート
	
	var imglst=document.createElement('div');
	var hourVal=-1; //
	for (var a=0; a<masterList.length; ++a) {
		if (hourVal!=masterList[a].Date[4]) {
			var hs=Separator('hourSeparator'); // hour separatorの組み込み
			if (hs) {
				hs.innerText=masterList[a].Date[4]+' o\'clock';
				imglst.appendChild(hs); 
			}
			hourVal=masterList[a].Date[4];
		}
		var pf=getThumbnailObj(masterList[a]);
		if (pf) { imglst.appendChild(pf); }
	}
	// alert(imglst.childNodes.length+' photo(s) in '+focusDate);
	
	setTimeout(isAllLoaded, 10, imglst);
}
	
// 描画すべき画像が全てloadされたことを確認し、確認されたら描画する関数
function isAllLoaded(imageList) {
	var isLoadComplete=true;
	var imgary=imageList.getElementsByTagName('img');
	for (var c=0; c<imgary.length; ++c) {
		if (false==imgary[c].complete) {
			isLoadComplete=false; break;
		}
	}
	if (isLoadComplete==false) { // すべての画像がloadし終わっていない場合
		setTimeout(isAllLoaded, 30, imageList);
		return;
	}
	
	// コンテンツをdiv id='pictboxArea'に設定
	var fc=document.getElementById('pictboxArea');
	if(fc && fc.firstChild) {
		fc.replaceChild(imageList, fc.firstChild);
	} else {
		fc.appendChild(imageList);
	}
	
	{ // データが動画であった場合のQT markを適切な位置に設定するための処理
		var mrks=fc.getElementsByTagName('div');
		for (var a=0; a<mrks.length; ++a) {
			if (mrks[a].className=='qtMark') {
				var posObj=getElementAbsPos(mrks[a].parentNode.firstChild);
				//alert(posObj.x+', '+posObj.y);
				mrks[a].style.position="absolute";
				mrks[a].style.top=(posObj.y+12)+'px';
				mrks[a].style.display="block";
			}
		}
	}
	
	//gPictArea.reveal(imageList);
	gPictArea.refresh();
	gPictBar.refresh();
}

//
function getThumbnailObj(photoObj) {
	var htmlStr=null;

	if (!photoObj.ThumbPath) { alert('No thumbnail path'); return ''; }
	
	// DIV block
	var bk=document.createElement("div"); // div block for photo frame
	if (!bk) { alert('failed to create DIV object!'); return null; }
	bk.setAttribute("class", "photoFrame");
	
	// IMG block
	var g=document.createElement("img"); // image block for thumbnail image.
	if (!g) { alert('failed to create IMG object!'); return null; }
	g.src=photoObj.ThumbPath;
	g.setAttribute("class", "theThumbnail");
	g.setAttribute("id", ''+photoObj.Id);
	g.complete=false;
	g.addEventListener("load", function(){ this.complete=true; }, false);
	g.addEventListener("click", clickThumbImage, false);
	bk.appendChild(g);

	if ("Movie"==photoObj.MediaType) {
		var bb=document.createElement("div");
		bb.setAttribute('class', 'qtMark');
		bb.style.backgroundImage="url(Images/QTicn.png)";
		bb.style.width="32px";
		bb.style.height="32px";
		//bb.style.position="absolute";
		bb.style.display="none";
		bk.appendChild(bb);
	}

	return bk;
}

//
function clickThumbImage(event) {
	var maxLen=304;
	
	// 画像または動画表示用の画面を用意する
	appearLargeImagePane();

	// 選択された画像/動画の属性情報を取得し、変数に保持する
	selectedPhotoAttr=getPhotoAttrById(event.target.id);
	
	var pm=document.getElementById('contentView');
	var ic=getDOMofIdleImg();
	if (ic) {
		ic.style.margin='24px';
		pm.appendChild(ic); // download中ですの画像を表示
	}
	
	if ("Movie"==selectedPhotoAttr.MediaType) {
		//cv.innerHTML=QT_GenerateOBJECTText_XHTML(selectedPhotoAttr.OriginalPath , '', '240' , '', 'name', 'aMovie', 'id', 'aMovie', 'AUTOPLAY', 'True', 'SCALE', 'Aspect', 'EnableJavaScript', 'False');
		
		var mvfnref= function() {
		var cv=document.createElement('div');
		cv.setAttribute('id', 'movieBlock');
		cv.addEventListener('click', function(e){ e.stopPropagation(); return false; }, false);
		cv.addEventListener('dragstart', function(e){ e.stopPropagation(); return false; }, false);
		cv.addEventListener('dragend', function(e){ e.stopPropagation(); return false; }, false);
		cv.addEventListener('drag', function(e){ e.stopPropagation(); return false; }, false);
		cv.addEventListener('mouseup', function(e){ e.stopPropagation(); return false; }, false);
		cv.addEventListener('mousedown', function(e){ e.stopPropagation(); return false; }, false);
		cv.addEventListener('mousemove', function(e){ e.stopPropagation(); return false; }, false);

		var qtobj=document.createElement('OBJECT');
		qtobj.setAttribute('classid', 'clsid:02BF25D5-8C17-4B23-BC80-D3488ABDDC6B');
		qtobj.setAttribute('width', '');
		qtobj.setAttribute('height', 240);
		qtobj.setAttribute('codebase', 'http://www.apple.com/qtactivex/qtplugin.cab');
		qtobj.id='aMovie';
		qtobj.style.padding="4px";
		qtobj.style.backgroundColor='white';
		
		var p1=document.createElement('param');
		p1.setAttribute('name','src');
		p1.setAttribute('value', selectedPhotoAttr.OriginalPath);
		qtobj.appendChild(p1);
		var p2=document.createElement('param');
		p2.setAttribute('name','autoplay');
		p2.setAttribute('value', 'True');
		qtobj.appendChild(p2);
		var p3=document.createElement('param');
		p3.setAttribute('name','scale');
		p3.setAttribute('value', 'Aspect');
		qtobj.appendChild(p3);
		var p4=document.createElement('param');
		p4.setAttribute('name','enablejavascript');
		p4.setAttribute('value', 'True');
		qtobj.appendChild(p4);
		
		var qtemb=document.createElement('EMBED');
		qtemb.setAttribute('src', selectedPhotoAttr.OriginalPath);
		qtemb.setAttribute('width', '');
		qtemb.setAttribute('height', 240);
		qtemb.setAttribute('pluginspage', 'http://www.apple.com/quicktime/download');
		qtemb.setAttribute('name', 'aMovie');
		qtemb.setAttribute('autoplay', 'True');
		qtemb.setAttribute('scale', 'Aspect');
		qtemb.setAttribute('EnableJavaScript', 'True');
		qtemb.setAttribute('name', 'aMovie');
		qtobj.addEventListener('load', function(){ alert('movie 1 loaded'); }, false);
		qtobj.appendChild(qtemb);
		cv.appendChild(qtobj);
		cv.style.marginTop='8pt';
		pm.replaceChild(cv, document.getElementById('idleCircle'));
		pm.appendChild(getDomOfTitleAndTime());
		document.getElementById('ViewIcon').src='Images/QTicn.png';
		};
		setTimeout(mvfnref, 1000);
		
	} else if ("Image"==selectedPhotoAttr.MediaType) {
		setTimeout(viewLargerImage, 10);
	}
	
	// focusをあててみる... が、意図した通りにはなっていないようだ...
	document.getElementById('closeOverBoxBtn').focus();
	
	return false;
}

// 
function viewLargerImage () {
	var maxLen=304;

	var limg=document.createElement('img');
	limg.src=selectedPhotoAttr.ImagePath;
	//limg.src=selectedPhotoAttr.ThumbPath;
	limg.style.marginTop='4px';
	limg.style.padding='4px';
	limg.style.backgroundColor='white';
	if (selectedPhotoAttr.AspectRatio < 1.0) {
		limg.height=maxLen*selectedPhotoAttr.AspectRatio;
	} else {
		limg.width=maxLen;
	}
	limg.addEventListener('load', function(){
		var x=document.getElementById('contentView');
		while(x.childNodes.length) { x.removeChild(x.childNodes[0]); }
		x.appendChild(this);
		x.appendChild(getDomOfTitleAndTime());
	}, false);
		
	// Previewボタンの画像をPreviewアプリの画像にする (画像用)
	document.getElementById('ViewIcon').src='Images/PreviewIcn.png';
}

// epochtimeでソートするための関数
function sortPhotosByEpoch (a, b) {
	return a.EpochTime - b.EpochTime;
}

// larger viewのタイトルと撮影時刻表示のためのDOM Treeを返す
function getDomOfTitleAndTime() {
	var base=document.createElement('div');
	
	var tn=document.createElement('div');
	tn.innerHTML=decodeURI(selectedPhotoAttr.Caption);
	tn.setAttribute("class", "imgTitle");
	base.appendChild(tn);
		
	tn=document.createElement('div');
	tn.setAttribute("class", "imgTime");
	tn.innerHTML=''+make2DigitStr(selectedPhotoAttr.Date[4])+':'+make2DigitStr(selectedPhotoAttr.Date[5]);
	base.appendChild(tn);
	
	return base;
}

// idle image (gif animation画像)の用意 (global variable)
function getDOMofIdleImg() {
	var gIImg=document.createElement('img');
	gIImg.setAttribute('id', 'idleCircle');
	gIImg.src='Images/idleCircle.gif';

	return gIImg;
}

// 回るアイコン画像をThumbnail表示領域に設定
function setIdleCursor () {
	var ig=getDOMofIdleImg();
	if (ig) {
		ig.style.position="absolute";
		ig.style.top='150px';
		ig.style.left='150px';
		var pba=document.getElementById('pictboxArea');
		while(pba.childNodes.length) { pba.removeChild(pba.childNodes[0]); }
		pba.appendChild(ig);
		
		gPictArea.refresh();
		gPictBar.refresh();
	}
}

//
function getPhotoAttrById(IDval) {
	var pAttr=null;
	
	for (var idx=0; idx<masterList.length; ++idx) {
		if (IDval == masterList[idx].Id) {
			pAttr=masterList[idx]; break;
		}
	}
	
	return pAttr;
}

// 数値を二桁の文字列にする 主に日付時刻表示用
function make2DigitStr(numVal) {
	var res=''+numVal;
	if (numVal < 10) {
		res='0'+res;
	} 
	return res;
}

//
function openWebPage(event) 
{
	widget.openURL('http://www.netaro.info/~zetaka/softwares/');
	return false;
}

// 
function appearLargeImagePane() {
	var ob=document.getElementById('overBox');
	if (ob) {
		// 背景を半透明板で覆う
		ob.style.display='block';
		ob.addEventListener("click", disappearLargeImagePane, false);
	}

	var pm=document.getElementById('contentView');
	if (pm) {
		pm.style.visibility='visible';
		pm.addEventListener('click', disappearLargeImagePane, false);
	}
	document.getElementById('iCalBtn').style.visibility='visible';
	document.getElementById('iPhotoBtn').style.visibility='visible';
	document.getElementById('PreviewBtn').style.visibility='visible';
	
	var aIcn=null;
	document.getElementById('iPhotoIcon').style.visibility='visible';
	aIcn=document.getElementById('iCalIcon');
	if (aIcn) {
		aIcn.style.visibility='visible';
	}
	document.getElementById('ViewIcon').style.visibility='visible';
}

// 
function disappearLargeImagePane() {
	document.getElementById('overBox').style.display='none';
	
	document.getElementById('contentView').style.visibility='hidden';
	document.getElementById('iCalBtn').style.visibility='hidden';
	document.getElementById('iPhotoBtn').style.visibility='hidden';
	document.getElementById('PreviewBtn').style.visibility='hidden';
	document.getElementById('iPhotoIcon').style.visibility='hidden';
	document.getElementById('iCalIcon').style.visibility='hidden';
	document.getElementById('ViewIcon').style.visibility='hidden';

	// movieが存在したら、再生を止める
	if (document.aMovie) {
		document.aMovie.Stop();
	}
	
	// 過去のデータ(全子ノード)を削除する
	var pm=document.getElementById('contentView');
	while (pm.childNodes.length) { pm.removeChild(pm.childNodes[0]); }

	selectedPhotoAttr=null;
}

// ---
function clickiCalBtn(event) 
{
	//alert('push iCalBtn!');
	
	if (null==focusDate || focusDate.length < 1) { return false; }
	var elem=focusDate.split('-');
	if (elem.length!=4) { return false; }
	var targetDate=elem[0]+'/'+elem[1]+'/'+elem[2];
	var osaScpt='/usr/bin/osascript ./openiCalWithDate.scpt ';
	osaScpt+='\''+targetDate+'\'';
	//alert("Apple Script cmd: "+osaScpt);
	widget.system(osaScpt, null);

	return false;
}

// ---
// openコマンドを利用して、オリジナルのメディアファイルを開く
function clickPreviewBtn(event) 
{
	//alert('push preview btn');
	var comStr='/usr/bin/open ';
	
	if (selectedPhotoAttr.OriginalPath) {
		comStr+='\''+decodeURI(selectedPhotoAttr.OriginalPath)+'\'';
	} else if (selectedPhotoAttr.ImagePath) {
		comStr+='\''+decodeURI(selectedPhotoAttr.ImagePath)+'\'';
	} else {
		return false;
	}
	//alert('command String: '+comStr);
	widget.system(comStr, null);
	
	// movieが存在していたら、とにかく再生を止める
	if (document.aMovie) {
		document.aMovie.Stop();
	}
	
	return false;
}

// ---
function clickiPhotoBtn(event) 
{
	//alert('push iPhoto btn');

	var comStr='/usr/bin/open -a /Applications/iPhoto.app';
	//alert('command String: '+comStr);
	widget.system(comStr, null);
}

function pictboxMouseOut(event) 
{
	//alert('pictbox mouse out');
	document.getElementById('pictboxArea').blur();
}

function pictboxMouseOver(event) 
{
	//alert('pictbox mouse over');
	document.getElementById('pictboxArea').focus();
}

function dateboxMouseOut(event) 
{
	//
	//alert('datebox mouse out'); 
	document.getElementById('dateBox').blur();
}


function dateboxMouseOver(event) 
{
	//
	//alert('datebox mouse over');
	document.getElementById('dateBox').focus();
}

//
function clickiCalIcon(event) 
{
	var x=document.getElementById('iCalBtn');
	x.object.onclick();
}

function downiCalIcon(event) 
{
	var x=document.getElementById('iCalBtn');
	x.object._mousedown(event);
}

function upiCalIcon(event) 
{
	var x=document.getElementById('iCalBtn');
	x.object._mouseup(event);
}

function clickiPhotoIcon(event) 
{
	var x=document.getElementById('iPhotoBtn');
	x.object.onclick();
}

function downiPhotoIcon(event) 
{
	var x=document.getElementById('iPhotoBtn');
	x.object._mousedown(event);
}

function upiPhotoIcon(event) 
{
	var x=document.getElementById('iPhotoBtn');
	x.object._mouseup(event);
}

function clickViewIcon(event) 
{
	var x=document.getElementById('PreviewBtn');
	x.object.onclick();
}

function downViewIcon(event) 
{
	var x=document.getElementById('PreviewBtn');
	x.object._mousedown(event);
}

function upViewIcon(event) 
{
	var x=document.getElementById('PreviewBtn');
	x.object._mouseup(event);
}
